	.data
jt:	.space 16		# allocate memory for jump table

	.text
	.globl main

main:	# load the jump table address into a register
	la $t4, jt		# t4 = jt

	# load the switch labels into registers
	la $t0, L0		# t0 = L0
	la $t1, L1		# t1 = L1
	la $t2, L2		# t2 = L2
	la $t3, L3		# t3 = L3

	# store the labels into the jump table
	sw $t0, 0($t4)		# jt[0] = L0
	sw $t1, 4($t4)		# jt[1] = L1
	sw $t2, 8($t4)		# jt[2] = L2
	sw $t3, 12($t4)		# jt[2] = L3

	# assign some values to all the variables
	li $s1, 1		# g = 1
	li $s2, 2		# h = 2
	li $s3, 3		# i = 3
	li $s4, 4		# j = 4
	li $s5, 1		# k = 1
	li $t3, 3		# t3 = 3

	# make sure 0 <= k <= 3
	blt $s5, $zero, Exit	# if k < 0, exit
	bgt $s5, $t3, Exit	# if k > 3, exit

	# index the jt and jump to the proper label
	sll $t1, $s5, 2		# t1 = 4*k
	add $t1, $t1, $t4	# t1 = jt + 4k
	lw $t0, 0($t1)		# t0 = jt[k]
	jr $t0			# jump to the label

L0:	add $s0, $s3, $s4	# f = i + j
	j Exit
L1:	add $s0, $s1, $s2	# f = g + h
	j Exit
L2:	sub $s0, $s1, $s2	# f = g - h
	j Exit
L3:	sub $s0, $s3, $s4	# f = i - j

Exit:	jr $31